"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsingHeaderAsChild = exports.DisabledItem = exports.FixedIndex = void 0;
var react_1 = __importDefault(require("react"));
var create_react_class_1 = __importDefault(require("create-react-class"));
var Accordion_1 = __importDefault(require("./Accordion"));
exports.default = {
    title: 'Layout/Accordion',
    component: Accordion_1.default,
    parameters: {
        docs: {
            description: {
                component: Accordion_1.default.peek.description,
            },
        },
    },
};
/* Fixed Index */
var FixedIndex = function () {
    var Component = (0, create_react_class_1.default)({
        render: function () {
            return (react_1.default.createElement(Accordion_1.default, { selectedIndex: 1 },
                react_1.default.createElement(Accordion_1.default.Item, { Header: 'Peter Venkman' }, "Peter Venkman, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters and Ghostbusters II and in the animated television series The Real Ghostbusters. In both live action films, he was portrayed by Bill Murray, and was voiced in the animated series first by Lorenzo Music and then by Dave Coulier. He is a parapsychologist and the leader of the Ghostbusters."),
                react_1.default.createElement(Accordion_1.default.Item, { Header: 'Ray Stantz' }, "Raymond Ray Stantz, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters, Ghostbusters II, Casper, and the animated television series The Real Ghostbusters. He was portrayed by Dan Aykroyd in both live action films, and voiced by Frank Welker in the animated series. He is a member of the Ghostbusters and one of the three doctors of parapsychology, along with Dr. Peter Venkman and Dr. Egon Spengler."),
                react_1.default.createElement(Accordion_1.default.Item, { Header: 'Egon Spengler' }, "Egon Spengler, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters and Ghostbusters II, in the animated television series The Real Ghostbusters, and later in Extreme Ghostbusters. Spengler was portrayed by Harold Ramis in the films and voiced by him in Ghostbusters: The Video Game, and voiced by Maurice LaMarche in the cartoon series. He is a member of the Ghostbusters and one of the three doctors of parapsychology, along with Dr. Peter Venkman and Dr. Raymond Stantz.")));
        },
    });
    return react_1.default.createElement(Component, null);
};
exports.FixedIndex = FixedIndex;
exports.FixedIndex.storyName = 'FixedIndex';
/* Disabled Item */
var DisabledItem = function () {
    var Component = (0, create_react_class_1.default)({
        render: function () {
            return (react_1.default.createElement(Accordion_1.default, null,
                react_1.default.createElement(Accordion_1.default.Item, { Header: 'Peter Venkman' }, "Peter Venkman, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters and Ghostbusters II and in the animated television series The Real Ghostbusters. In both live action films, he was portrayed by Bill Murray, and was voiced in the animated series first by Lorenzo Music and then by Dave Coulier. He is a parapsychologist and the leader of the Ghostbusters."),
                react_1.default.createElement(Accordion_1.default.Item, { Header: 'Ray Stantz', isDisabled: true }, "Raymond Ray Stantz, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters, Ghostbusters II, Casper, and the animated television series The Real Ghostbusters. He was portrayed by Dan Aykroyd in both live action films, and voiced by Frank Welker in the animated series. He is a member of the Ghostbusters and one of the three doctors of parapsychology, along with Dr. Peter Venkman and Dr. Egon Spengler."),
                react_1.default.createElement(Accordion_1.default.Item, { Header: 'Egon Spengler' }, "Egon Spengler, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters and Ghostbusters II, in the animated television series The Real Ghostbusters, and later in Extreme Ghostbusters. Spengler was portrayed by Harold Ramis in the films and voiced by him in Ghostbusters: The Video Game, and voiced by Maurice LaMarche in the cartoon series. He is a member of the Ghostbusters and one of the three doctors of parapsychology, along with Dr. Peter Venkman and Dr. Raymond Stantz.")));
        },
    });
    return react_1.default.createElement(Component, null);
};
exports.DisabledItem = DisabledItem;
exports.DisabledItem.storyName = 'DisabledItem';
/* Using Header As Child */
var UsingHeaderAsChild = function () {
    var Component = (0, create_react_class_1.default)({
        render: function () {
            return (react_1.default.createElement(Accordion_1.default, null,
                react_1.default.createElement(Accordion_1.default.Item, null,
                    react_1.default.createElement(Accordion_1.default.Header, null, "Peter Venkman"),
                    "Peter Venkman, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters and Ghostbusters II and in the animated television series The Real Ghostbusters. In both live action films, he was portrayed by Bill Murray, and was voiced in the animated series first by Lorenzo Music and then by Dave Coulier. He is a parapsychologist and the leader of the Ghostbusters."),
                react_1.default.createElement(Accordion_1.default.Item, { isDisabled: true },
                    react_1.default.createElement(Accordion_1.default.Header, null, "Ray Stantz"),
                    "Raymond Ray Stantz, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters, Ghostbusters II, Casper, and the animated television series The Real Ghostbusters. He was portrayed by Dan Aykroyd in both live action films, and voiced by Frank Welker in the animated series. He is a member of the Ghostbusters and one of the three doctors of parapsychology, along with Dr. Peter Venkman and Dr. Egon Spengler."),
                react_1.default.createElement(Accordion_1.default.Item, null,
                    react_1.default.createElement(Accordion_1.default.Header, null, "Egon Spengler"),
                    "Egon Spengler, Ph.D. is a fictional character from the Ghostbusters franchise. He appears in the films Ghostbusters and Ghostbusters II, in the animated television series The Real Ghostbusters, and later in Extreme Ghostbusters. Spengler was portrayed by Harold Ramis in the films and voiced by him in Ghostbusters: The Video Game, and voiced by Maurice LaMarche in the cartoon series. He is a member of the Ghostbusters and one of the three doctors of parapsychology, along with Dr. Peter Venkman and Dr. Raymond Stantz.")));
        },
    });
    return react_1.default.createElement(Component, null);
};
exports.UsingHeaderAsChild = UsingHeaderAsChild;
exports.UsingHeaderAsChild.storyName = 'UsingHeaderAsChild';
//# sourceMappingURL=Accordion.stories.js.map