"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SmallDataTableSkeleton = void 0;
var react_1 = __importDefault(require("react"));
var LoadingSkeleton_1 = __importDefault(require("./LoadingSkeleton"));
var LoadingSkeletonsSvgUtil_1 = require("./LoadingSkeletonsSvgUtil");
var SmallDataTableSkeleton = function (props) {
    var _a = props.width, width = _a === void 0 ? 565 : _a, _b = props.height, height = _b === void 0 ? 130 : _b, className = props.className;
    return (react_1.default.createElement("div", { "data-test-id": 'loadingSkeleton-SmallDataTableSkeleton' },
        react_1.default.createElement("svg", { "data-test-id": 'loadingSkeleton-SmallDataTableSkeleton-svg', width: width, height: height, version: '1.1', xmlns: 'http://www.w3.org/2000/svg' },
            react_1.default.createElement("g", { id: 'SmallDataTableSkeleton-Details', stroke: 'none', strokeWidth: '1', fill: 'none', fillRule: 'evenodd' },
                react_1.default.createElement("g", { id: 'SmallDataTableSkeleton-Group-1', transform: 'translate(-598.000000, -2418.000000)' },
                    react_1.default.createElement("g", { id: 'SmallDataTableSkeleton-Group-2', transform: 'translate(30.000000, 2241.000000)' },
                        react_1.default.createElement("g", { id: 'SmallDataTableSkeleton-Group-3', transform: 'translate(568.000000, 177.000000)' },
                            react_1.default.createElement("g", { id: 'Table-Row-/-Default', transform: 'translate(0.000000, 30.000000)' },
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundNeutral)('&', className), id: 'SmallDataTableSkeleton-BG', x: '0', y: '0', width: '565', height: '32' }),
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundGray)('&', className), id: 'SmallDataTableSkeleton-Bottom-Line', x: '0', y: '31', width: '565', height: '1' })),
                            react_1.default.createElement("g", { id: 'SmallDataTableSkeleton-Table-Row-/-Default', transform: 'translate(0.000000, 62.000000)' },
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundNeutral)('&', className), id: 'SmallDataTableSkeleton-BG', x: '0', y: '0', width: '565', height: '32' }),
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundGray)('&', className), id: 'SmallDataTableSkeleton-Bottom-Line', x: '0', y: '31', width: '565', height: '1' })),
                            react_1.default.createElement("g", { id: 'SmallDataTableSkeleton-Table-Row-/-Default', transform: 'translate(0.000000, 94.000000)' },
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundNeutral)('&', className), id: 'SmallDataTableSkeleton-BG', x: '0', y: '0', width: '565', height: '32' }),
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundGray)('&', className), id: 'SmallDataTableSkeleton-Bottom-Line', x: '0', y: '31', width: '565', height: '1' })),
                            react_1.default.createElement("g", { id: 'Table-Row-/-Header-White' },
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundNeutral)('&', className), id: 'SmallDataTableSkeleton-BG', x: '0', y: '0', width: '565', height: '30' }),
                                react_1.default.createElement("rect", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundGray)('&', className), id: 'SmallDataTableSkeleton-Bottom-Line', x: '0', y: '29', width: '565', height: '1' })),
                            react_1.default.createElement("path", { className: (0, LoadingSkeletonsSvgUtil_1.cxBackgroundGray)('&', className), d: 'M111,104 L111,114 L11,114 L11,104 L111,104 Z M289,104 L289,114 L189,114 L189,104 L289,104 Z M477,\n                  104 L477,114 L377,114 L377,104 L477,104 Z M131,72 L131,82 L11,82 L11,72 L131,72 Z M309,72 L309,82 L189,\n                  82 L189,72 L309,72 Z M497,72 L497,82 L377,82 L377,72 L497,72 Z M111,40 L111,50 L11,50 L11,40 L111,40 Z M289,\n                  40 L289,50 L189,50 L189,40 L289,40 Z M477,40 L477,50 L377,50 L377,40 L477,40 Z M131,10 L131,20 L11,\n                  20 L11,10 L131,10 Z M309,10 L309,20 L189,20 L189,10 L309,10 Z M497,10 L497,20 L377,20 L377,10 L497,10 Z', id: 'SmallDataTableSkeleton-Combined-Shape' }))))))));
};
exports.SmallDataTableSkeleton = SmallDataTableSkeleton;
var SmallDataTableLoadingSkeleton = function (props) {
    return (react_1.default.createElement(LoadingSkeleton_1.default, __assign({ "data-test-id": 'loadingSkeleton-SmallDataTableLoadingSkeleton', Skeleton: exports.SmallDataTableSkeleton }, props)));
};
SmallDataTableLoadingSkeleton.displayName = 'SmallDataTableLoadingSkeleton';
SmallDataTableLoadingSkeleton.peek = {
    description: "A loading indicator wrapper with optional overlay.",
    notes: {
        overview: "\n\t\t\tA visual indication that a section or component of the interface is loading. Designed to indicate loading data\n\t\t",
        intendedUse: "\n\t\t\t- Use in places where data takes time to load. SmallDataTableLoadingSkeleton lets users know that the information they expect to see will appear shortly.\t\t\n\t\t",
        technicalRecommendations: "\n\t\t\tIf a page is displaying a lot of data coming from multiple sources, try as best as possible to load the \n\t\t\tindividual parts of the UI, so as not to disrupt the user and block them from interacting with the entire page until all data is loaded.\n\t\t",
    },
    categories: ['Loading Indicator'],
};
exports.default = SmallDataTableLoadingSkeleton;
//# sourceMappingURL=SmallDataTableLoadingSkeleton.js.map