"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.totalPagesSelector = void 0;
var lodash_1 = __importDefault(require("lodash"));
function totalPagesSelector(_a) {
    var pageSizeOptions = _a.pageSizeOptions, selectedPageSizeIndex = _a.selectedPageSizeIndex, totalCount = _a.totalCount, totalPages = _a.totalPages;
    var pageSize = pageSizeOptions[selectedPageSizeIndex];
    return lodash_1.default.isNumber(totalPages)
        ? totalPages
        : totalCount <= pageSize
            ? 1
            : Math.floor(totalCount / pageSize) + lodash_1.default.clamp(totalCount % pageSize, 0, 1);
}
exports.totalPagesSelector = totalPagesSelector;
exports.default = {
    totalPages: totalPagesSelector,
};
//# sourceMappingURL=Paginator.selectors.js.map