"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithResponsiveGrid = exports.WithTopMargin = exports.WithResize = exports.WithoutResize = exports.WithoutAnimation = exports.WithLeftPosition = exports.WithHeader = exports.WithDefaults = exports.NoModal = void 0;
var react_1 = __importStar(require("react"));
var Panel_1 = __importDefault(require("../Panel/Panel"));
var SidePanel_1 = __importDefault(require("./SidePanel"));
var ResponsiveGrid_1 = __importDefault(require("../ResponsiveGrid/ResponsiveGrid"));
exports.default = {
    title: 'Layout/SidePanel',
    component: SidePanel_1.default,
    parameters: {
        docs: {
            description: {
                component: SidePanel_1.default.peek.description,
            },
        },
    },
    args: SidePanel_1.default.defaultProps,
};
/* No Modal */
var NoModal = function (args) {
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "modal can be disabled in the underlying Overlay component to allow interaction with the background"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isModal: false, isExpanded: isExpanded, onCollapse: handleToggle, Header: 'Stumptown keytar schlitz' },
            react_1.default.createElement("p", null, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", null, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.NoModal = NoModal;
/* With Defaults */
var WithDefaults = function (args) {
    var margins = {
        margin: '0 0 16px 0',
    };
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "expand and collapse SidePanel by passing the isExpanded prop"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isExpanded: isExpanded, onCollapse: handleToggle },
            react_1.default.createElement("p", { style: margins }, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", { style: margins }, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.WithDefaults = WithDefaults;
/* With Header */
var WithHeader = function (args) {
    var margins = {
        margin: '0 0 16px 0',
    };
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "render a header with a close button"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isExpanded: isExpanded, onCollapse: handleToggle, width: 500 },
            react_1.default.createElement(SidePanel_1.default.Header, null,
                react_1.default.createElement("div", null,
                    react_1.default.createElement("div", null,
                        react_1.default.createElement("strong", null, "Rich content")))),
            react_1.default.createElement("p", { style: margins }, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", { style: margins }, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.WithHeader = WithHeader;
/* With Left Position */
var WithLeftPosition = function (args) {
    var margins = {
        margin: '0 0 16px 0',
    };
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "position of the SidePanel can be aligned on either side of the page"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isExpanded: isExpanded, onCollapse: handleToggle, position: 'left', Header: 'Stumptown keytar schlitz' },
            react_1.default.createElement("p", { style: margins }, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", { style: margins }, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.WithLeftPosition = WithLeftPosition;
/* Without Animation */
var WithoutAnimation = function (args) {
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "transition animations can be disabled if desired"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isAnimated: false, isExpanded: isExpanded, onCollapse: handleToggle, Header: 'Stumptown keytar schlitz' },
            react_1.default.createElement("p", null, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", null, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.WithoutAnimation = WithoutAnimation;
/* Without Resize */
var WithoutResize = function (args) {
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "prevent resizing width by hiding the resizer"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isResizeDisabled: true, isExpanded: isExpanded, onCollapse: handleToggle, Header: 'Stumptown keytar schlitz' },
            react_1.default.createElement("p", null, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", null, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.WithoutResize = WithoutResize;
/* With Resize */
var WithResize = function (args) {
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var _b = (0, react_1.useState)(240), width = _b[0], setWidth = _b[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    var handleResize = function (width) {
        setWidth(width);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "resized width is obtatined with a callback"),
        react_1.default.createElement("p", null,
            "SidePanel width: ",
            width),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isExpanded: isExpanded, width: width, onCollapse: handleToggle, Header: 'Stumptown keytar schlitz', onResize: handleResize },
            react_1.default.createElement("p", null, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", null, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.WithResize = WithResize;
/* With Top Margin */
var WithTopMargin = function (args) {
    var margins = {
        margin: '0 0 16px 0',
    };
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "render the component with a top margin"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isExpanded: isExpanded, onCollapse: handleToggle, topOffset: 50 },
            react_1.default.createElement(SidePanel_1.default.Header, null,
                react_1.default.createElement("div", null,
                    react_1.default.createElement("div", null,
                        react_1.default.createElement("strong", null, "Rich content")))),
            react_1.default.createElement("p", { style: margins }, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
            react_1.default.createElement("p", { style: margins }, "Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher."))));
};
exports.WithTopMargin = WithTopMargin;
/* With Responsive Grid */
var WithResponsiveGrid = function (args) {
    var _a = (0, react_1.useState)(true), isExpanded = _a[0], setIsExpanded = _a[1];
    var handleToggle = function () {
        setIsExpanded(!isExpanded);
    };
    return (react_1.default.createElement("section", null,
        react_1.default.createElement("p", null, "modal can be disabled in the underlying Overlay component to allow interaction with the background"),
        react_1.default.createElement("button", { onClick: handleToggle }, "Toggle SidePanel"),
        react_1.default.createElement(SidePanel_1.default, { isModal: false, isExpanded: isExpanded, onCollapse: handleToggle, Header: 'Stumptown keytar schlitz' },
            react_1.default.createElement("div", null,
                react_1.default.createElement(Panel_1.default, { hasMargin: false, style: { marginBottom: '12px' } }, "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid."),
                react_1.default.createElement(ResponsiveGrid_1.default, { breakPoints: [480, 960] },
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "1"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "2"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby xitarian gentrify cray. Kogi subway tile gochujang dreamcatcher.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "3"),
                            "trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "4"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "5"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "6"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "7"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "8"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher. kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "9"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher. Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "10"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst ethical. Sartorial umami cardigan, farm-to-table bespoke 90's schlitz cray drinking vinegar actually freegan bushwick wolf. Shabby chic tofu celiac shaman, twee af squid blue bottle street art. Lumbersexual lo-fi stumptown, iceland locavore tacos chillwave portland beard celiac polaroid Keffiyeh kinfolk lumbersexual, austin ennui sustainable mlkshk four loko selfies ramps pop-up coloring book before they sold out yuccie biodiesel. Yuccie taxidermy beard, +1 church-key umami echo park synth. Fanny pack farm-to-table pok pok, next level trust fund live-edge asymmetrical art party intelligentsia listicle sriracha. Tote bag ugh meggings, selfies vegan blog locavore messenger bag chambray etsy heirloom cronut enamel pin hammock umami. Bushwick venmo activated charcoal, mumblecore skateboard hashtag literally brooklyn etsy ennui 3 wolf moon. Before they sold out blog iPhone subway tile, truffaut dreamcatcher organic raclette portland whatever brooklyn succulents flexitarian gentrify cray. Kogi subway tile gochujang dreamcatcher.")),
                    react_1.default.createElement(ResponsiveGrid_1.default.Cell, null,
                        react_1.default.createElement(Panel_1.default, { hasMargin: false },
                            react_1.default.createElement(Panel_1.default.Header, null, "11"),
                            "Stumptown keytar schlitz, vinyl vexillologist humblebrag sartorial crucifix cornhole. Four dollar toast 8-bit taiyaki asymmetrical helvetica kitsch farm-to-table thundercats. Occupy hammock waistcoat pabst.")))))));
};
exports.WithResponsiveGrid = WithResponsiveGrid;
//# sourceMappingURL=SidePanel.stories.js.map