import _ from 'lodash';
import React from 'react';
import { Badge } from './Badge';
const kinds = [undefined, 'primary', 'success', 'danger'];
const types = [undefined, 'stroke'];
export default {
    title: 'Visual Design/Badge',
    component: Badge,
    parameters: {
        docs: {
            description: {
                component: Badge.peek.description,
            },
        },
    },
};
//👇 We create a “template” of how args map to rendering
const Template = (args) => React.createElement(Badge, { ...args }, "Badge");
//👇 Each story then reuses that template
export const Basic = Template.bind({});
export const AllTypes = (args) => (React.createElement("div", null, _.map(kinds, (kind, idx) => (React.createElement("div", { key: `${kind}-${idx}` }, _.map(types, (ty) => (React.createElement(React.Fragment, { key: `${kind}-${ty}` },
    React.createElement(Badge, { ...args, style: { marginBottom: '10px', marginRight: '10px' }, kind: kind, type: ty }, "Badge")))))))));
//# sourceMappingURL=Badge.stories.js.map