import React, { useState } from 'react';
import Collapsible from './Collapsible';
import Button from '../Button/Button';
import SingleSelect from '../SingleSelect/SingleSelect';
export default {
    title: 'Utility/Collapsible',
    component: Collapsible,
    parameters: {
        docs: {
            description: {
                component: Collapsible.peek.description,
            },
        },
    },
};
/* Toggle Expand */
export const ToggleExpand = (args) => {
    const [isExpanded, setIsExpanded] = useState(true);
    const handleToggle = () => {
        setIsExpanded(!isExpanded);
    };
    return (React.createElement("section", null,
        React.createElement(Button, { onClick: handleToggle }, "toggle"),
        React.createElement(Collapsible, { ...args, isExpanded: isExpanded, style: { background: '#f4f2f2', padding: 10 } },
            React.createElement("p", null, "Kitsch aesthetic gluten-free bitters affogato, you probably haven't heard of them DIY in cornhole sunt meditation man braid cardigan. Selfies stumptown sriracha, small batch williamsburg synth organic aute mlkshk beard venmo normcore XOXO freegan chambray. Freegan delectus next level nostrud intelligentsia swag. Pabst delectus selfies kale chips, duis pariatur locavore iPhone. Chia 3 wolf moon tofu messenger bag pop-up intelligentsia. Pinterest excepteur yuccie four dollar toast DIY. Plaid drinking vinegar locavore id mustache."),
            React.createElement("p", null, "Flexitarian gentrify taxidermy, bitters chambray swag etsy brunch kogi pork belly authentic. Direct trade put a bird on it ad bespoke, occaecat marfa cliche nisi aliquip kale chips synth readymade. Odio austin keytar pour-over fugiat. Pickled everyday carry laborum sartorial pinterest labore, organic voluptate banh mi kitsch. Leggings austin thundercats cliche. Neutra typewriter sapiente, intelligentsia semiotics +1 esse ex authentic aesthetic banh mi drinking vinegar knausgaard. Id tousled culpa, ut chia cillum actually fashion axe cronut forage assumenda tilde ramps."))));
};
/* Not Animated */
export const NotAnimated = (args) => {
    const [isExpanded, setIsExpanded] = useState(true);
    const handleToggle = () => {
        setIsExpanded(!isExpanded);
    };
    return (React.createElement("section", null,
        React.createElement(Button, { onClick: handleToggle }, "toggle"),
        React.createElement(Collapsible, { ...args, isAnimated: false, isExpanded: isExpanded, style: { background: '#f4f2f2', padding: 10 } },
            React.createElement("p", null, "Kitsch aesthetic gluten-free bitters affogato, you probably haven't heard of them DIY in cornhole sunt meditation man braid cardigan. Selfies stumptown sriracha, small batch williamsburg synth organic aute mlkshk beard venmo normcore XOXO freegan chambray. Freegan delectus next level nostrud intelligentsia swag. Pabst delectus selfies kale chips, duis pariatur locavore iPhone. Chia 3 wolf moon tofu messenger bag pop-up intelligentsia. Pinterest excepteur yuccie four dollar toast DIY. Plaid drinking vinegar locavore id mustache."),
            React.createElement("p", null, "Flexitarian gentrify taxidermy, bitters chambray swag etsy brunch kogi pork belly authentic. Direct trade put a bird on it ad bespoke, occaecat marfa cliche nisi aliquip kale chips synth readymade. Odio austin keytar pour-over fugiat. Pickled everyday carry laborum sartorial pinterest labore, organic voluptate banh mi kitsch. Leggings austin thundercats cliche. Neutra typewriter sapiente, intelligentsia semiotics +1 esse ex authentic aesthetic banh mi drinking vinegar knausgaard. Id tousled culpa, ut chia cillum actually fashion axe cronut forage assumenda tilde ramps."))));
};
/* Unmount Children On Collapse */
export const UnmountChildrenOnCollapse = (args) => {
    const [isExpanded, setIsExpanded] = useState(true);
    const handleToggle = () => {
        setIsExpanded(!isExpanded);
    };
    return (React.createElement("section", null,
        React.createElement(Button, { onClick: handleToggle }, "toggle"),
        React.createElement(Collapsible, { ...args, isExpanded: isExpanded, style: { background: '#f4f2f2', padding: 10 } },
            React.createElement("p", null, "Kitsch aesthetic gluten-free bitters affogato, you probably haven't heard of them DIY in cornhole sunt meditation man braid cardigan. Selfies stumptown sriracha, small batch williamsburg synth organic aute mlkshk beard venmo normcore XOXO freegan chambray. Freegan delectus next level nostrud intelligentsia swag. Pabst delectus selfies kale chips, duis pariatur locavore iPhone. Chia 3 wolf moon tofu messenger bag pop-up intelligentsia. Pinterest excepteur yuccie four dollar toast DIY. Plaid drinking vinegar locavore id mustache."),
            React.createElement(SingleSelect, { DropMenu: { isExpanded: true } },
                React.createElement(SingleSelect.Option, null, "Will"),
                React.createElement(SingleSelect.Option, null, "Not"),
                React.createElement(SingleSelect.Option, null, "Remain")),
            React.createElement("p", null, "Flexitarian gentrify taxidermy, bitters chambray swag etsy brunch kogi pork belly authentic. Direct trade put a bird on it ad bespoke, occaecat marfa cliche nisi aliquip kale chips synth readymade. Odio austin keytar pour-over fugiat. Pickled everyday carry laborum sartorial pinterest labore, organic voluptate banh mi kitsch. Leggings austin thundercats cliche. Neutra typewriter sapiente, intelligentsia semiotics +1 esse ex authentic aesthetic banh mi drinking vinegar knausgaard. Id tousled culpa, ut chia cillum actually fashion axe cronut forage assumenda tilde ramps."))));
};
/* Render Children On Collapse */
export const RenderChildrenOnCollapse = (args) => {
    const [isExpanded, setIsExpanded] = useState(true);
    const handleToggle = () => {
        setIsExpanded(!isExpanded);
    };
    return (React.createElement("section", null,
        React.createElement(Button, { onClick: handleToggle }, "toggle"),
        React.createElement(Collapsible, { ...args, isMountControlled: false, isExpanded: isExpanded, style: { background: '#f4f2f2', padding: 10 } },
            React.createElement("p", null, "Kitsch aesthetic gluten-free bitters affogato, you probably haven't heard of them DIY in cornhole sunt meditation man braid cardigan. Selfies stumptown sriracha, small batch williamsburg synth organic aute mlkshk beard venmo normcore XOXO freegan chambray. Freegan delectus next level nostrud intelligentsia swag. Pabst delectus selfies kale chips, duis pariatur locavore iPhone. Chia 3 wolf moon tofu messenger bag pop-up intelligentsia. Pinterest excepteur yuccie four dollar toast DIY. Plaid drinking vinegar locavore id mustache."),
            React.createElement("div", { style: { display: 'flex', justifyContent: 'center' } },
                React.createElement(SingleSelect, { DropMenu: { isExpanded: true } },
                    React.createElement(SingleSelect.Option, null, "Will"),
                    React.createElement(SingleSelect.Option, null, "Stay"),
                    React.createElement(SingleSelect.Option, null, "Rendered"))),
            React.createElement("p", null, "Flexitarian gentrify taxidermy, bitters chambray swag etsy brunch kogi pork belly authentic. Direct trade put a bird on it ad bespoke, occaecat marfa cliche nisi aliquip kale chips synth readymade. Odio austin keytar pour-over fugiat. Pickled everyday carry laborum sartorial pinterest labore, organic voluptate banh mi kitsch. Leggings austin thundercats cliche. Neutra typewriter sapiente, intelligentsia semiotics +1 esse ex authentic aesthetic banh mi drinking vinegar knausgaard. Id tousled culpa, ut chia cillum actually fashion axe cronut forage assumenda tilde ramps."))));
};
/* Toggle With On Rest Callback */
export const ToggleWithOnRestCallback = (args) => {
    const onRest = () => {
        alert('I am and always will be the optimist. The hoper of far-flung hopes and the dreamer of improbable dreams.');
    };
    const [isExpanded, setIsExpanded] = useState(false);
    const handleToggle = () => {
        setIsExpanded(!isExpanded);
    };
    return (React.createElement("section", null,
        React.createElement(Button, { onClick: handleToggle }, "toggle"),
        React.createElement(Collapsible, { ...args, isExpanded: isExpanded, style: { background: '#f4f2f2', padding: 10 }, onRest: onRest },
            React.createElement("p", null, "Everybody knows that everybody dies. But not every day. Not today. Some days are special. Some days are so, so blessed. Some days, nobody dies at all. Now and then, every once in a very long while, every day in a million days, when the wind stands fair and the Doctor comes to call, everybody lives."))));
};
ToggleWithOnRestCallback.storyName = 'Toggle With OnRest Callback';
//# sourceMappingURL=Collapsible.stories.js.map