import { omit } from 'lodash';
import React from 'react';
import Icon, { propTypes as iconPropTypes } from '../Icon';
import { lucidClassNames } from '../../../util/style-helpers';
const cx = lucidClassNames.bind('&-SeparatorIcon');
export const SeparatorIcon = ({ className, ...passThroughs }) => {
    return (React.createElement(Icon, { ...omit(passThroughs, ['initialState']), className: cx('&', className) },
        React.createElement("path", { d: 'M5.2 0h1.5l4 8-4 8H5.2l4-8-4-8z' })));
};
SeparatorIcon._isPrivate = true;
SeparatorIcon.displayName = 'SeparatorIcon';
SeparatorIcon.peek = {
    description: `A separator icon.`,
    categories: ['visual design', 'icons'],
    extend: 'Icon',
    madeFrom: ['Icon'],
};
SeparatorIcon.propTypes = iconPropTypes;
SeparatorIcon.defaultProps = Icon.defaultProps;
export default SeparatorIcon;
//# sourceMappingURL=SeparatorIcon.js.map