import React from 'react';
import PropTypes from 'prop-types';
import { StandardProps } from '../../util/component-types';
export interface ITitleProps extends StandardProps {
}
export interface IProgressBarProps extends StandardProps, React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement> {
    /** Applies a color style for the kind of ProgressBar. */
    kind: 'default' | 'success' | 'danger' | 'info' | 'warning';
    /** Percentage ProgressBar is complete. */
    percentComplete: number;
    /** *Child Element* - Title contents. Only one \`Title\` is used. */
    Title?: string | (React.ReactNode & {
        props: ITitleProps;
    });
}
export declare const ProgressBar: {
    (props: IProgressBarProps): React.ReactElement;
    defaultProps: {
        kind: "default";
        percentComplete: number;
    };
    Title: {
        (_props: ITitleProps): null;
        displayName: string;
        propName: string;
        peek: {
            description: string;
        };
    };
    displayName: string;
    peek: {
        description: string;
        categories: string[];
    };
    propTypes: {
        /**
            Appended to the component-specific class names set on the root element.
        */
        className: PropTypes.Requireable<string>;
        /**
            Applies a color style for the kind of ProgressBar.
        */
        kind: PropTypes.Requireable<string>;
        /**
            Percentage ProgressBar is complete.
        */
        percentComplete: PropTypes.Requireable<number>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        Title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    };
};
export default ProgressBar;
//# sourceMappingURL=ProgressBar.d.ts.map