import React from 'react';
import { lucidClassNames } from '../../util/style-helpers';
import PropTypes from 'prop-types';
const cx = lucidClassNames.bind('&-TextFieldPlain');
const TextFieldPlain = React.forwardRef(({ isDisabled = false, isMultiLine = false, ...props }, ref) => {
    const className = cx('&', {
        '&-is-disabled': isDisabled,
        '&-is-multi-line': isMultiLine,
        '&-is-single-line': !isMultiLine,
    }, props.className);
    if (isMultiLine) {
        return (React.createElement("textarea", { ref: ref, ...props, className: className }));
    }
    else {
        return (React.createElement("input", { ref: ref, ...props, className: className }));
    }
});
// @ts-ignore
TextFieldPlain.propTypes = {
    isDisabled: PropTypes.bool,
    isMultiLine: PropTypes.bool,
    className: PropTypes.string,
};
TextFieldPlain.displayName = 'TextFieldPlain';
export default TextFieldPlain;
//# sourceMappingURL=TextFieldPlain.js.map