/// <reference types="react" />
export interface ITimeSelect {
    /** JS Date for the time to display and update	*/
    time: Date;
    /** Set to true to display the TimeSelect as a 24 hour clock. Set to false
            to display the TimeSelect as a 12 hour clock */
    is24HourClock?: boolean;
    /** The callback that will take a new Date object */
    onChange(time: Date): void;
    /** Set to true to disable the TimeSelect */
    isDisabled?: boolean;
}
declare enum MeridiemType {
    AM = "AM",
    PM = "PM"
}
declare const TimeSelect: {
    ({ time, is24HourClock, onChange, isDisabled, }: ITimeSelect): JSX.Element;
    peek: {
        description: string;
        notes: {
            overview: string;
            technicalRecommendations: string;
            intendedUse: string;
        };
        categories: string[];
    };
    defaultProps: {
        time: Date;
    };
};
export default TimeSelect;
export { MeridiemType };
//# sourceMappingURL=TimeSelect.d.ts.map