declare type IClientRect = Omit<ClientRect, 'x' | 'y' | 'toJSON'>;
export declare function getAbsoluteBoundingClientRect(domNode: HTMLElement | null): IClientRect;
export declare function scrollParentTo(domNode: HTMLElement | null, additionalOffset?: number): void;
export declare function dispatchDOMEvent(node: EventTarget, eventName: string, assignedEventProps?: any): Event;
/**
 * sharesAncestor
 *
 * Recursively looks at `node` and its parents for `nodeName` and makes
 * sure it contains `siblingNode`.
 *
 * @param {Node} node - dom node to check if any of its ancestors are a `<label>`
 * @param {Node} siblingNode - dom node to see if it shares an ancestor
 * @param {string} nodeName - dom node name, should be uppercased, e.g. `LABEL` or `SPAN`
 * @returns {boolean}
 */
export declare function sharesAncestor(node: Node, siblingNode: Node | null, nodeName: string): boolean;
export declare function shiftChildren(parent: HTMLElement, n?: number): void;
export {};
//# sourceMappingURL=dom-helpers.d.ts.map